"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var __1 = require("..");
var force_error_impl_1 = require("./force-error-impl");
var async = require("async");
var fs = require("fs");
var readlineSync = require('readline-sync');
var inpathSync = require('inpath').sync;
var psTree = require('ps-tree');
var SpawnImpl = (function (_super) {
    __extends(SpawnImpl, _super);
    function SpawnImpl(commandUtil, safeJson, positive, childProcessSpawn) {
        var _this = _super.call(this) || this;
        _this.commandUtil = commandUtil;
        _this.safeJson = safeJson;
        _this.positive = positive;
        _this.childProcessSpawn = childProcessSpawn;
        return _this;
    }
    SpawnImpl_1 = SpawnImpl;
    SpawnImpl.prototype.validate_spawnShellCommandAsync_args = function (cmd, options, cbStatus, cbFinal, cbDiagnostic) {
        if (cbDiagnostic === void 0) { cbDiagnostic = null; }
        var me = this;
        cmd = cmd || [];
        cmd = cmd.slice(0);
        options = options || {};
        options.preSpawnMessage = options.preSpawnMessage || '';
        options.postSpawnMessage = options.postSpawnMessage || '';
        options.sudoUser = options.sudoUser || '';
        options.sudoPassword = options.sudoPassword || '';
        options.stdio = options.stdio || 'pipe';
        options.cwd = options.cwd || process.cwd();
        cbStatus = me.checkCallback(cbStatus);
        cbFinal = me.checkCallback(cbFinal);
        cbDiagnostic = cbDiagnostic || (function () {
        });
        return { cmd: cmd, options: options, cbStatus: cbStatus, cbFinal: cbFinal, cbDiagnostic: cbDiagnostic };
    };
    SpawnImpl.prototype.spawnShellCommandAsync = function (_cmd, _options, _cbStatus, _cbFinal, _cbDiagnostic) {
        if (_cbDiagnostic === void 0) { _cbDiagnostic = null; }
        var me = this;
        var _a = me.validate_spawnShellCommandAsync_args(_cmd, _options, _cbStatus, _cbFinal, _cbDiagnostic), cmd = _a.cmd, options = _a.options, cbStatus = _a.cbStatus, cbFinal = _a.cbFinal, cbDiagnostic = _a.cbDiagnostic;
        if (me.checkForceError('spawnShellCommandAsync', cbFinal)) {
            return;
        }
        if (!options.remoteHost && !options.remoteUser && !options.remotePassword) {
            return me._spawnShellCommandAsync(cmd, options, cbStatus, cbFinal, cbDiagnostic);
        }
        if (!options.remoteHost || !options.remoteUser || !options.remotePassword) {
            throw new Error('If any of options.(remoteHost|remoteUser|remotePassword) are specified all must be specified');
        }
        var tmp = require('tmp');
        tmp.file({ discardDescriptor: true }, function (err, tmpPath) {
            if (err) {
                return cbFinal(err, 'Failed to create temporary file');
            }
            var remoteHost = options.remoteHost, remoteUser = options.remoteUser, remotePassword = options.remotePassword;
            var subShellOptions = {
                suppressDiagnostics: true,
                suppressStdOut: true,
                suppressStdErr: true,
                cacheStdOut: true,
                cacheStdErr: true,
                suppressResult: false,
            };
            var envBashCmd = [
                '/usr/bin/env',
                'bash',
                '-c'
            ];
            var sshpassCmd = [
                'sshpass',
                '-p',
                remotePassword
            ];
            var sshpassScpCmd = sshpassCmd.concat([
                'scp'
            ]);
            var sshpassSshCmd = sshpassCmd.concat([
                'ssh',
                '-t'
            ]);
            async.waterfall([
                function (cb) {
                    var writeStream = fs.createWriteStream(tmpPath);
                    writeStream.on('close', function () {
                        cb();
                    });
                    writeStream.write(cmd.join(' '), function () {
                        writeStream.close();
                    });
                },
                function (cb) {
                    var cmd = sshpassScpCmd.concat([
                        tmpPath,
                        remoteUser + "@" + remoteHost + ":/tmp"
                    ]);
                    me._spawnShellCommandAsync(cmd, subShellOptions, function () {
                    }, cb);
                },
                function (result, cb) {
                    var cmd = sshpassSshCmd.concat(remoteUser + "@" + remoteHost + " \"echo " + remotePassword + " | sudo -S /usr/bin/env bash " + tmpPath + "\"");
                    var _cmd = envBashCmd.concat(cmd.join(' '));
                    me._spawnShellCommandAsync(_cmd, subShellOptions, function (err, result) {
                        me.commandUtil.log(result);
                    }, cb);
                },
                function (result, cb) {
                    var cmd = sshpassSshCmd.concat(remoteUser + "@" + remoteHost + " \"rm " + tmpPath + "\"");
                    var _cmd = envBashCmd.concat(cmd.join(' '));
                    me._spawnShellCommandAsync(_cmd, subShellOptions, function (err, result) {
                        me.commandUtil.log(result);
                    }, cb);
                }
            ], function (outerErr, result) {
                if (outerErr) {
                    me.safeJson.safeParse(outerErr.message, function (err, obj) {
                        try {
                            switch (typeof obj.code) {
                                case ('object'):
                                    switch (obj.code.code) {
                                        case ('ENOENT'):
                                            if (me.positive.areYouSure("Looks like 'sshpass' is not installed. Want me to try to install it (using apt-get)?", 'Operation canceled.', true, __1.FailureRetVal.TRUE)) {
                                                return me.sudoSpawnAsync([
                                                    'apt-get',
                                                    'install',
                                                    '-y',
                                                    'sshpass'
                                                ], {
                                                    suppressDiagnostics: true,
                                                    suppressStdOut: false,
                                                    suppressStdErr: false,
                                                    cacheStdOut: false,
                                                    cacheStdErr: false,
                                                    sudoPassword: 'password',
                                                    suppressResult: true,
                                                }, function (err, result) {
                                                    me.commandUtil.log(result);
                                                }, function (err) {
                                                    cbFinal(err, err ? err.message : "'sshpass' installed. Try operation again.");
                                                });
                                            }
                                            break;
                                        default:
                                            return cbFinal(outerErr, outerErr.message);
                                    }
                                    break;
                                case ('number'):
                                    return cbFinal(outerErr, obj.stderrText);
                                default:
                                    return cbFinal(outerErr, outerErr.message);
                            }
                        }
                        catch (err) {
                            cbFinal(err, "Original Error: " + outerErr.message);
                        }
                    });
                }
                else {
                    cbFinal(null, 'OK');
                }
            });
        });
    };
    SpawnImpl.prototype._spawnShellCommandAsync = function (cmd, options, cbStatus, cbFinal, cbDiagnostic) {
        if (cbDiagnostic === void 0) { cbDiagnostic = null; }
        var me = this;
        var childProcess;
        try {
            if (options.forceNullChildProcess) {
                throw new Error('error: forceNullChildProcess');
            }
            var command = cmd[0];
            var args = cmd.slice(1);
            var stdoutText_1 = '';
            var stderrText_1 = '';
            if (!options.suppressDiagnostics) {
                cbDiagnostic("Running '" + cmd + "' @ '" + options.cwd + "'");
                options.preSpawnMessage && cbDiagnostic(options.preSpawnMessage);
            }
            try {
                childProcess = me.childProcessSpawn.spawn(command, args, options);
            }
            catch (err) {
                if (err.message === 'Path must be a string. Received undefined') {
                    throw new Error('Bad argument');
                }
                throw err;
            }
            childProcess.stderr.on('data', function (dataChunk) {
                if (options.suppressStdErr && !options.cacheStdErr) {
                    return;
                }
                var text = dataChunk.toString();
                !options.suppressStdErr && cbStatus(new Error(text), text);
                options.cacheStdErr && (stderrText_1 += text);
            });
            childProcess.stdout.on('data', function (dataChunk) {
                if (options.suppressStdOut && !options.cacheStdOut) {
                    return;
                }
                var text = dataChunk.toString();
                !options.suppressStdOut && cbStatus(null, text);
                options.cacheStdOut && (stdoutText_1 += text);
            });
            childProcess.on('error', function (code, signal) {
                cbFinal = SpawnImpl_1.childCloseOrExit(code || 10, signal || '', stdoutText_1, stderrText_1, options, cbFinal, cbDiagnostic);
            });
            childProcess.on('exit', function (code, signal) {
                cbFinal = SpawnImpl_1.childCloseOrExit(code, signal || '', stdoutText_1, stderrText_1, options, cbFinal, cbDiagnostic);
            });
            childProcess.on('close', function (code, signal) {
                cbFinal = SpawnImpl_1.childCloseOrExit(code, signal || '', stdoutText_1, stderrText_1, options, cbFinal, cbDiagnostic);
            });
        }
        catch (err) {
            cbFinal && cbFinal(err, null);
        }
        return childProcess;
    };
    SpawnImpl.childCloseOrExit = function (code, signal, stdoutText, stderrText, options, cbFinal, cbDiagnostic) {
        if (cbFinal) {
            !options.suppressDiagnostics && options.postSpawnMessage && cbDiagnostic(options.postSpawnMessage);
            var returnString = JSON.stringify({ code: code, signal: signal, stdoutText: stdoutText, stderrText: stderrText }, undefined, 2);
            var error = (code !== null && code !== 0)
                ? new Error(returnString)
                : null;
            cbFinal(options.suppressFinalError ? null : error, options.suppressResult ? '' : returnString);
        }
        return null;
    };
    SpawnImpl.prototype.sudoSpawnAsync = function (_cmd, _options, _cbStatus, _cbFinal, _cbDiagnostic) {
        if (_cbDiagnostic === void 0) { _cbDiagnostic = null; }
        var me = this;
        var _a = me.validate_spawnShellCommandAsync_args(_cmd, _options, _cbStatus, _cbFinal, _cbDiagnostic), cmd = _a.cmd, options = _a.options, cbStatus = _a.cbStatus, cbFinal = _a.cbFinal, cbDiagnostic = _a.cbDiagnostic;
        if (me.checkForceError('sudoSpawnAsync', cbFinal)) {
            return;
        }
        var prompt = '#login-prompt#';
        var args = ['-S', '-p', prompt];
        if (options.sudoUser) {
            args.unshift("--user=" + options.sudoUser);
        }
        [].push.apply(args, cmd);
        var path = process.env['PATH'].split(':');
        var sudoBin = inpathSync('sudo', path);
        args.unshift(sudoBin);
        var childProcess = me.spawnShellCommandAsync(args, options, function (err, result) {
            if (err) {
                try {
                    var lines = result.toString().trim().split('\n');
                    for (var i = 0; i < lines.length; ++i) {
                        if (lines[i] === prompt) {
                            return;
                        }
                    }
                }
                catch (err) {
                }
            }
            cbStatus(err, result);
        }, function (err, result) {
            if (result) {
                var regex = new RegExp(prompt, 'g');
                result = result.replace(regex, '');
            }
            cbFinal(err, result);
        }, cbDiagnostic);
        if (!childProcess) {
            return;
        }
        function waitForStartup(err, children) {
            if (err) {
                throw new Error("Error spawning process");
            }
            if (children && children.length) {
                childProcess.stderr.removeAllListeners();
            }
            else {
                setTimeout(function () {
                    psTree(childProcess.pid, waitForStartup);
                }, 100);
            }
        }
        psTree(childProcess.pid, waitForStartup);
        var prompts = 0;
        childProcess.stderr.on('data', function (data) {
            var lines = data.toString().trim().split('\n');
            lines.forEach(function (line) {
                if (line === prompt) {
                    if (++prompts > 1) {
                        me.cachedPassword = null;
                    }
                    var username = require('username').sync();
                    if (!me.cachedPassword) {
                        if (options.sudoPassword) {
                            me.cachedPassword = options.sudoPassword;
                        }
                        else {
                            try {
                                var loginMessage = (prompts > 1)
                                    ? "Sorry, try again.\n[sudo] password for " + username + ": "
                                    : "[sudo] password for " + username + ": ";
                                me.cachedPassword = readlineSync.question(loginMessage, { hideEchoBack: true });
                            }
                            catch (err) {
                                childProcess.kill();
                                return;
                            }
                        }
                    }
                    childProcess.stdin.write(me.cachedPassword + '\n');
                }
            });
        });
        return childProcess;
    };
    var SpawnImpl_1;
    SpawnImpl = SpawnImpl_1 = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject('CommandUtil')),
        __param(1, inversify_1.inject('SafeJson')),
        __param(2, inversify_1.inject('Positive')),
        __param(3, inversify_1.inject('ChildProcessSpawn')),
        __metadata("design:paramtypes", [Object, Object, Object, Object])
    ], SpawnImpl);
    return SpawnImpl;
}(force_error_impl_1.ForceErrorImpl));
exports.SpawnImpl = SpawnImpl;
//# sourceMappingURL=spawn-impl.js.map