"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
var inversify_config_1 = require("../inversify.config");
var chai = require("chai");
var sinon = require("sinon");
var expect = chai.expect;
describe('ProgressBar', function () {
    var progressBar;
    beforeEach(function () {
        progressBar = inversify_config_1.default.get('ProgressBar');
    });
    describe('create using kernel', function () {
        it('should be created by kernel', function (done) {
            expect(progressBar).to.not.equal(null);
            done();
        });
    });
    describe('should call console.log', function () {
        var consoleLogSpy;
        before(function () {
            consoleLogSpy = sinon.spy(console, 'log');
        });
        it('console.log() was called', function (done) {
            progressBar.showProgressForTask('id', 'status', 50, 100);
            expect(consoleLogSpy.called).to.equal(true);
            done();
        });
        after(function () {
            console.log.restore();
        });
    });
    describe('should call console.log with "> 50 : 100"', function () {
        var consoleLogStub;
        before(function () {
            consoleLogStub = sinon.stub(console, 'log', function (msg) {
                expect(msg).to.equal('> 50 : 100');
            });
        });
        it('console.log() was called', function (done) {
            progressBar.showProgressForTask('id', 'status', 50, 100);
            expect(consoleLogStub.called).to.equal(true);
            done();
        });
        after(function () {
            console.log.restore();
        });
    });
});
//# sourceMappingURL=progress-bar.test.js.map